using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Sample
{
    public partial class formMain : Form
    {
        // fR[h͈͎wiformSetRectŐݒj
        public static bool blnEnableSetRect = false;
        public static int nRectLeft = 0;
        public static int nRectTop = 0;
        public static int nRectRight = 0;
        public static int nRectBottom = 0;

        // fR[hݒiformSetPropertyŐݒj
        public static int nSymbolCount = 0;
        public static int nEffectLevel = 3;
        public static byte byBorder = 0;
        public static byte byModuleSize = 1;

        private int nFilterIndex = 1;

        public formMain()
        {
            InitializeComponent();
        }

        private void formMain_Resize(object sender, EventArgs e)
        {
            // eLXg{bNXNCAg̈ɍ킹ĕ\
            textDecodeResult.Width = ClientRectangle.Width;
            textDecodeResult.Height = ClientRectangle.Height - menuStrip1.Height;
        }

        private void textDecodeResult_DragEnter(object sender, DragEventArgs e)
        {
            // t@Ĉ݃hbOhbv
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.Copy;
        }

        private void textDecodeResult_DragDrop(object sender, DragEventArgs e)
        {
            // t@Chbv

            DecodeFile(((string[])e.Data.GetData(DataFormats.FileDrop))[0]);
        }

        private void menuFileOpen_Click(object sender, EventArgs e)
        {
            // [t@C]-[J]

            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.Filter = "sN` t@C (*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png)|*.bmp;*.jpg;*.jpeg;*.gif;*.tif;*.tiff;*.png|" +
                                     "rbg}bv t@C (*.bmp)|*.bmp|" +
                                     "JPEG ` (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
                                     "GIF ` (*.gif)|*.gif|" +
                                     "TIFF ` (*.tif;*.tiff)|*.tif;*.tiff|" + 
                                     "PNG ` (*.png)|*.png|" +
                                     "ׂẴt@C (*.*)|*.*";
            openFileDialog1.FilterIndex = nFilterIndex;
            openFileDialog1.RestoreDirectory = true;

            // R_CAOɂt@CI
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                nFilterIndex = openFileDialog1.FilterIndex;
                DecodeFile(openFileDialog1.FileName);
            }
        }

        private void menuAppExit_Click(object sender, EventArgs e)
        {
            //vOI
            Close();
        }

        private void menuSetDecodeRect_Click(object sender, EventArgs e)
        {
            // fR[h͈͎w_CAO\
            formSetRect setRectDialog = new formSetRect();

            setRectDialog.ShowDialog(); // [_\

            setRectDialog.Dispose();
        }

        private void menuSetDecodeProperty_Click(object sender, EventArgs e)
        {
            // fR[hݒ_CAO\
            formSetProperty setPropertyDialog = new formSetProperty();

            setPropertyDialog.ShowDialog(); // [_\

            setPropertyDialog.Dispose();
        }

        private void DecodeFile(String strFilePath)
        {
            // 摜t@CΏۂƂfR[h

          	string strSeparator = "\r\n";
            string[] strLevel = { "L(7%)", "M(15%)", "Q(25%)", "H(30%)" };

            // vJ[\\
            Cursor = System.Windows.Forms.Cursors.WaitCursor;

            // DLLt@NVɂfR[h
            int nResult;

            if (blnEnableSetRect)
            {
                // ͈͎w肠
                nResult = PsyQrDcd.DecodePictureFileRect(strFilePath, nRectLeft, nRectTop, nRectRight, nRectBottom);
            }
            else
            {    // ͈͎wȂ
                nResult = PsyQrDcd.DecodePictureFile(strFilePath);
            }

            // J[\
            Cursor = System.Windows.Forms.Cursors.Default;

            string strResult = ""; // fR[hʕieLXg{bNX\pj

	        if (nResult >= 1)
	        {
		        // fR[hI
		        for (int i = 0; i < nResult; ++i)
		        {
                    strResult += strSeparator;

			        string strWork;

			        // V{^ԁAx
                    strWork = string.Format("fR[h f[^ {0} [^:{1}, x:{2}", i + 1, PsyQrDcd.GetDecodeVersion(i), strLevel[PsyQrDcd.GetDecodeLevel(i)]);
			        strResult += strWork;

			        // V{A
			        int nSeqNo = 0;
			        byte byCheckDigit = 0;

                    int ncConcatenation = PsyQrDcd.GetConcatenationInfo(i, ref nSeqNo, ref byCheckDigit);

			        if (ncConcatenation > 0)
			        {
                        strWork = string.Format(", A:{0}/{1}(CD:{2:X2}H)", nSeqNo + 1, ncConcatenation, byCheckDigit);
				        strResult += strWork;
			        }

			        strResult += "]\r\n";

                    strResult += strSeparator;

			        // V{f[^
                    StringBuilder strBuff = new StringBuilder(7089);

                    PsyQrDcd.GetDecodeData(i, ref strBuff);

                    strResult += strBuff;

                    strResult += "\r\n\r\n";

			        // V{ʒu
                    int[] nPosition = new int[8];

                    PsyQrDcd.GetSymbolePosition(i, nPosition);

                    strWork = string.Format("V{ʒuF({0}, {1})-({2}, {3})-({4}, {5})-({6}, {7})",
                                            nPosition[0], nPosition[1], nPosition[2], nPosition[3],
                                            nPosition[4], nPosition[5], nPosition[6], nPosition[7]); 
			        strResult += strWork;
			        strResult += "\r\n\r\n";
		        }

                // fR[hʕۑJ
                PsyQrDcd.FreeAllocateMemory();
            }
	        else
	        {
		        switch (nResult)
		        {
                case (int)DecodeResult.QRD_ERROR_SYMBLE_NOT_FOUND:
			        strResult = "QRR[h V{ǂݎ܂łB";

                    switch (PsyQrDcd.GetErrorLevel())
                    {
                        case 1:
                            strResult += "\r\n";
                            strResult += "(ʒuop^[܂łB)";
			                break;                    

                        case 2:
                            strResult += "\r\n";
                            strResult += "(ʒuop^[V{Fł܂łB)";
			                break;

                        case 3:
                            strResult += "\r\n";
                            strResult += "(f[^̓ǂݎɎs܂B)";
			                break;                    

                        default:
			                break;                    
                    }

                    break;

                case (int)DecodeResult.QRD_ERROR_FILE_NOT_FOUND:
			        strResult = "t@C܂łB";
			        break;

                case (int)DecodeResult.QRD_ERROR_READ_FAULT:
			        strResult = "t@CǂݍݒɃG[܂B";
			        break;

                case (int)DecodeResult.QRD_ERROR_BAD_FORMAT:
			        strResult = "ǂݎłȂt@CʂłB";
			        break;

                case (int)DecodeResult.QRD_ERROR_SHARING_VIOLATION:
			        strResult = "Lᔽɂt@Cǂݎ邱Ƃł܂łB";
			        break;

                case (int)DecodeResult.QRD_ERROR_NOT_ENOUGH_MEMORY:
			        strResult = "słB";
			        break;

		        default:
			        break;
		        }
	        }

            textDecodeResult.Text = strResult;
        }
    }
}
