using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Sample
{
    public partial class formSetRect : Form
    {
        public formSetRect()
        {
            InitializeComponent();
        }

        private void formSetRect_Load(object sender, EventArgs e)
        {
            // ݒ\
            if (formMain.blnEnableSetRect)
                radioEnableSetRect.Checked = true;
            else
                radioDisableSetRect.Checked = true;

            textRectLeft.Text = formMain.nRectLeft.ToString();
            textRectTop.Text = formMain.nRectTop.ToString();
            textRectRight.Text = formMain.nRectRight.ToString();
            textRectBottom.Text = formMain.nRectBottom.ToString();

            EnableEditControl(formMain.blnEnableSetRect);
        }

        private void radioDisableSetRect_Click(object sender, EventArgs e)
        {
            // W͕s
            EnableEditControl(false);
        }

        private void radioEnableSetRect_Click(object sender, EventArgs e)
        {
            // W͉
            EnableEditControl(true);
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            // ݒۑ
            formMain.blnEnableSetRect = radioEnableSetRect.Checked;

            formMain.nRectLeft = int.Parse(textRectLeft.Text);
            formMain.nRectTop = int.Parse(textRectTop.Text);
            formMain.nRectRight = int.Parse(textRectRight.Text);
            formMain.nRectBottom = int.Parse(textRectBottom.Text);

            Close();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void EnableEditControl(bool blnEnable)
        {
            // W̓eLXg{bNXL^؂芷

            textRectLeft.Enabled = blnEnable;
            textRectLeft.ReadOnly = ! blnEnable;

            textRectTop.Enabled = blnEnable;
            textRectTop.ReadOnly = ! blnEnable;

            textRectRight.Enabled = blnEnable;
            textRectRight.ReadOnly = ! blnEnable;

            textRectBottom.Enabled = blnEnable;
            textRectBottom.ReadOnly = ! blnEnable;
        }
    }
}
